package com.bocloud.ims.repository.resource.azure.db;

import com.bocloud.common.exception.BoCloudDBException;
import com.bocloud.common.model.Pager;
import com.bocloud.common.model.Param;
import com.bocloud.common.model.SimpleBean;
import com.bocloud.common.utils.Common;
import com.bocloud.common.utils.MapTools;
import com.bocloud.database.core.BasicDao;
import com.bocloud.database.utils.QueryBuilder;
import com.bocloud.ims.entity.resource.azure.price.AzureResourcePrice;
import com.google.common.collect.Lists;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: AzureResourcePriceRepository
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/2/7 9:41
 */
@Repository("azureResourcePriceRepository")
public class AzureResourcePriceRepository extends BasicDao {

    public List<SimpleBean> list(List<Param> params, Map<String, String> sorter) throws BoCloudDBException {
        String sql = "select * from azure_resource_price where 1=1";
        sql = QueryBuilder.buildRaw(sql, new Pager(1, Integer.MAX_VALUE, params, sorter), "");
        Map<String, Object> paramMap = QueryBuilder.getParam(params);
        List<AzureResourcePrice> list = this.queryForList(sql, paramMap, AzureResourcePrice.class).stream().map(o -> (AzureResourcePrice) o).collect(Collectors.toList());
        List<SimpleBean> beans = Lists.newArrayList();
        for (AzureResourcePrice entity : list) {
            beans.add(new SimpleBean(entity.getResourceType(), entity.getProductType()));
        }
        return beans;
    }

    public List<AzureResourcePrice> list(int page, int rows, List<Param> params, Map<String, String> sorter) throws BoCloudDBException {
        String sql = "SELECT a.* " +
                "FROM azure_resource_price a " +
                "WHERE 1=1 ";
        sql = QueryBuilder.buildRaw(sql, new Pager(page, rows, params, sorter), "a");
        Map<String, Object> paramMap = QueryBuilder.getParam(params);
        return this.queryForList(sql, paramMap, AzureResourcePrice.class).stream().map(o -> (AzureResourcePrice) o).collect(Collectors.toList());
    }

    public int count(List<Param> params) throws BoCloudDBException {
        String sql = "SELECT COUNT(1) " +
                "FROM azure_resource_price a " +
                "WHERE 1=1 ";
        sql = QueryBuilder.buildRaw(sql, params, null, "a");
        Map<String, Object> paramMap = QueryBuilder.getParam(params);
        return this.countQuery(sql, paramMap).intValue();
    }

    public AzureResourcePrice query(Long id) throws BoCloudDBException {
        String sql = "select a.* from azure_resource_price a where  a.id = :id ";
        Map<String, Object> params = MapTools.simpleMap("id", id);
        List<AzureResourcePrice> list = this.queryForList(sql, params, AzureResourcePrice.class).stream().map(o -> (AzureResourcePrice) o).collect(Collectors.toList());
        if (list.isEmpty()) {
            return null;
        }
        return list.get(0);
    }

    public List<AzureResourcePrice> list() throws BoCloudDBException {
        String sql = "select * from azure_resource_price ";
        List<AzureResourcePrice> list = this.queryForList(sql, null, AzureResourcePrice.class).stream().map(o -> (AzureResourcePrice) o).collect(Collectors.toList());
        if (list.isEmpty()) {
            return null;
        }
        return list;
    }

    public AzureResourcePrice save(AzureResourcePrice ip) throws BoCloudDBException {
        return (AzureResourcePrice) this.saveEntity(ip);
    }

    public Boolean update(AzureResourcePrice ip) throws BoCloudDBException {
        return this.updateEntity(ip);
    }

    public Boolean delete(Long id) throws BoCloudDBException {
        String sql = "delete from azure_resource_price where id = :id";
        Map<String, Object> params = MapTools.simpleMap(Common.ID, id);
        return this.update(sql, params) > 0;
    }


}